glibmm: Gio::Initable Class Reference

glibmm 2.38.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::Initable Class Reference

Failable object initialization interface. More...

`#include <giomm/initable.h>`

Inheritance diagram for Gio::Initable:
[legend]

## Public Member Functions
virtual | ~Initable ()
GInitable* | gobj ()
| Provides access to the underlying C GObject. More...
const GInitable* | gobj () const
| Provides access to the underlying C GObject. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
virtual | ~Interface ()
GObject* | gobj ()
const GObject* | gobj () const
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| Initable ()
| You should derive from this class to use it. More...
void | init (const Glib::RefPtr< Cancellable >& cancellable)
| Initializes the object implementing the interface. More...
void | init ()
| A init() convenience overload. More...
virtual bool | init_vfunc (const Glib::RefPtr< Cancellable >& cancellable, GError** error)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::Initable > | wrap (GInitable* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

Failable object initialization interface.

Initable is implemented by objects that can fail during initialization. If an object implements this interface the init() function must be called as the first thing after construction. If init() is not called, or if it returns an error, all further operations on the object should fail, generally with a G_IO_ERROR_NOT_INITIALIZED error.

Users of objects implementing this are not intended to use the interface method directly, instead it will be used automatically in various ways. For C applications you generally just call g_initable_new() directly, or indirectly via a foo_thing_new() wrapper. This will call g_initable_init() under the cover, returning NULL and setting a GError on failure.

For bindings in languages where the native constructor supports exceptions the binding could check for objects implemention GInitable during normal construction and automatically initialize them, throwing an exception on failure.

Since glibmm 2.24:

## Constructor & Destructor Documentation

Gio::Initable::Initable | ( |  | ) |
| protected

You should derive from this class to use it.

virtual Gio::Initable::~Initable | ( |  | ) |
| virtual

## Member Function Documentation

static void Gio::Initable::add_interface | ( | GType | gtype_implementer | ) |
| static

static GType Gio::Initable::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GInitable* Gio::Initable::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GInitable* Gio::Initable::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

void Gio::Initable::init | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |
| protected

Initializes the object implementing the interface.

The object must be initialized before any real use after initial construction, either with this function or g_async_initable_init_async().

Implementations may also support cancellation. If cancellable is not `0`, then initialization can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error IO_ERROR_CANCELLED will be returned. If cancellable is not `0` and the object doesn't support cancellable initialization the error IO_ERROR_NOT_SUPPORTED will be returned.

If the object is not initialized, or initialization returns with an error, then all operations on the object except Glib::object_ref() and Glib::object_unref() are considered to be invalid, and have undefined behaviour. See the <xref linkend="ginitable"> section introduction for more details.

Implementations of this method must be idempotent, i.e. multiple calls to this function with the same argument should return the same results. Only the first call initializes the object, further calls return the result of the first call. This is so that it's safe to implement the singleton pattern in the GObject constructor function.

Since glibmm 2.22:

Parameters

  cancellable | Optional Cancellable object, `0` to ignore.

Returns
  `true` if successful. If an error has occurred, this function will return `false` and set error appropriately if present.

void Gio::Initable::init | ( |  | ) |
| protected

A init() convenience overload.

virtual bool Gio::Initable::init_vfunc | ( | const Glib::RefPtr< Cancellable >& | cancellable,
|  | GError ** | error
| ) |  |
| protectedvirtual

## Friends And Related Function Documentation

Glib::RefPtr< Gio::Initable > wrap | ( | GInitable * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.